// RobTrew  Twitter: @ComplexPoint June 2015
(function (strPaletteName, strAcross, strDown) {
	strPaletteName = (strPaletteName.toLowerCase() !== 'global') ?
		strPaletteName : "Keyboard Maestro";

	strAcross = strAcross ? strAcross.toLowerCase() : 'left';
	strDown = strDown ? strDown.toLowerCase() : 'top';

	// strName --> oWin
	function namedPalWin(strName) {
		var lstWins = lngWins ? fnWins.whose({
			name: strName
		}) : [];
		return lstWins.length ? lstWins[0] : null;
	}

	// A corner point a middle point
	// oWindow --> [left|middle|right] --> [top|middle|bottom] --> [lngX, lngY]
	function palPoint(winPal, strX, strY) {

		if (['left', 'horizontal', 'right'].indexOf(strX) === -1) strX = 'left';
		if (['top', 'vertical', 'bottom'].indexOf(strY) === -1) strY = 'top';

		var lstXY = winPal.position(),
			lstWH = winPal.size();

		return [
			lstXY[0] + (strX !== 'left' ?
				(strX === 'horizontal' ? lstWH[0] / 2 : lstWH[0]) : 0),
			lstXY[1] + (strY !== 'top' ?
				(strY === 'vertical' ? lstWH[1] / 2 : lstWH[1]) : 0)
		];
	}

	var appSE = Application("System Events"),
		lstProcs = appSE.applicationProcesses.whose({
			name: "Keyboard Maestro Engine"
		}),
		procKME = (lstProcs && lstProcs.length) ? lstProcs[0] : null;

	var fnWins = procKME ? procKME.windows : null,
		lngWins = fnWins ? fnWins.length : 0,
		palNamed = namedPalWin(strPaletteName),
		rgxSpace = /\s+/,
		strReturn = '',
		lstPosn;

	if (palNamed) {
		lstPosn = palPoint(
			palNamed,
			strAcross.split(rgxSpace)[0],
			strDown.split(rgxSpace)[0]
		);
		// Format usable as KM Variable for Mouse Position etc
		strReturn = lstPosn[0].toString() + ', ' + lstPosn[1].toString();
	} else {
		strReturn = "Palette not open, or not found as spelled: " + strPaletteName;
	}

	return strReturn;

})("Global", 'horizontal centre', 'vertical centre');